#include "stdafx.h"
#include <cassert>
#include <fstream>
#include <iostream>
#include <iostream>
#include <boost/smart_ptr.hpp>
#include <boost/algorithm/string.hpp>
#include "tinyxml2.h"
#include "Odds2_HitCoefficient.h"
#include "FileEncrypt.h"
std::auto_ptr<Odds2_HitCoefficient> Odds2_HitCoefficient::msSingleton(nullptr);

int Odds2_HitCoefficient::GetCount()
{
	return (int)mMapData.size();
}

const Odds2_HitCoefficientData* Odds2_HitCoefficient::GetData(int BuffID)
{
	auto it = mMapData.find(BuffID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

boost::unordered_map<int, Odds2_HitCoefficientData>& Odds2_HitCoefficient::GetMapData()
{
	return mMapData;
}

void Odds2_HitCoefficient::Reload()
{
	mMapData.clear();
	Load();
}

void Odds2_HitCoefficient::Load(const std::string& path)
{
	std::ifstream readStream(path, std::ios::binary);
	if (!readStream.is_open())
	{
		assert(false);
		return;
	}
	readStream.seekg(0, std::ios::end);
	int fileSize = readStream.tellg();
	boost::shared_array<char> buffer(new char[fileSize+1]);
	buffer.get()[fileSize] = '\0';
	readStream.seekg(0, std::ios::beg);
	readStream.read(buffer.get(), fileSize);
	readStream.close();
	FileEncrypt::decryptBuffer( buffer, fileSize );
	tinyxml2::XMLDocument xmlDoc;
	auto result = xmlDoc.Parse(buffer.get(), fileSize);
	if (result != tinyxml2::XML_SUCCESS)
	{
		assert(false);
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		assert(false);
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		Odds2_HitCoefficientData data;
		data.mBuffID = element->IntAttribute("BuffID");
		data.mCaptureNumber = element->IntAttribute("CaptureNumber");
		data.mBuffEffectMin = element->IntAttribute("BuffEffectMin");
		{
			const char* BossId = element->Attribute("BossId");
			std::vector<std::string> vecBossId;
			boost::split(vecBossId, BossId, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecBossId.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecBossId[i].c_str(), &temp))
				{
					data.mBossId.push_back(temp);
				}
			}
		}
		if (mMapData.find(data.mBuffID) != mMapData.end())std::cout <<"data refind:" << data.mBuffID << std::endl;
		assert(mMapData.find(data.mBuffID) == mMapData.end());
		mMapData.insert(std::make_pair(data.mBuffID, data));
		element = element->NextSiblingElement();
	}
}

void Odds2_HitCoefficient::Load()
{
	Load("../Config/Odds2_HitCoefficient.xml");
}

Odds2_HitCoefficient* Odds2_HitCoefficient::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new Odds2_HitCoefficient());
	}
	return msSingleton.get();
}
